/*
fuzzy.hh

This C++ header file defines the class FUZZY_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
5-Oct-99	Modified by RCS-Design tool.
21-Sep-99	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef FUZZY_HH
#define FUZZY_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "fuzzy_sys.hh" // FUZZY_SYS
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "fuzzyn.hh" 	// NML Commands and Status definitions for fuzzy
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class FUZZY_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	FUZZY_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(FUZZY_INIT *);
	virtual void HALT(FUZZY_HALT *);
	virtual void RUN(FUZZY_RUN *);
	virtual void SET_DEFUZZ(FUZZY_SET_DEFUZZ *);
	virtual void SET_INPUT_GAINS(FUZZY_SET_INPUT_GAINS *);
	virtual void SET_IN_MF(FUZZY_SET_IN_MF *);
	virtual void SET_IN_UD(FUZZY_SET_IN_UD *);
	virtual void SET_OUTPUT_GAINS(FUZZY_SET_OUTPUT_GAINS *);
	virtual void SET_OUT_MF(FUZZY_SET_OUT_MF *);
	virtual void SET_OUT_UD(FUZZY_SET_OUT_UD *);
	virtual void SET_PREMISE(FUZZY_SET_PREMISE *);

	// Convenience Variables
	FUZZY_STATUS *fuzzy_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
	int num_of_fuzzy_inputs;
	int num_of_fuzzy_outputs;
	FUZZY_SYS *fuzzy_sys;
	double inputs_to_fuzzy[NUM_OF_FUZZY_INPUTS];
	double outputs_of_fuzzy[NUM_OF_FUZZY_OUTPUTS];

};

#endif 	// FUZZY_HH



